#include "main.h"
#include "ip.h"
#include "mqtt.h"
#include "serial.h"
#include "delay.h"
#include "opensh.h"

void *opensh(void *arg)
{ 
    sleep(10);
   opencamsh();
   return NULL; 
}

void *serial_usart1(void *arg)
{ 
    printf("serial_usart 1 start\n");
    
    serial_Receive_1();

    return NULL; 
}

void *AppExit(void *arg)
{ 

      

    while(1)
    {    
        unsigned char bufpwm1[3]={gtypeTemp,1,0};
        unsigned char bufpwm2[3]={gtypeTemp,2,0};
        unsigned char bufpwm3[3]={gtypeTemp,3,0};
        unsigned char bufpwm4[3]={gtypeTemp,4,0};
        Delay_Ms(0,100);
        gPwmCount++;
        //printf( "%d\n",gtypeTemp);
        if(gPwmCount>20)
        {
            //printf( "%d\n",gtypeTemp);
        gPwmCount=21;
        serial_Write(bufpwm1);
        serial_Write(bufpwm2);
        serial_Write(bufpwm3);
        serial_Write(bufpwm4);
        } 
    }
    
    return NULL; 
}

void *Mqttbeat(void *arg)
{
    printf("Mqttbeat start\n");
   
    
    while(1)
    {
        mqtt_wirte();
        Delay_Ms(3,200);
    }
    
    
    return NULL;
}

void *serial_usart2(void *arg)
{ 
    
    printf("serial_usart 2 start\n");
    serial_Receive_2();

}

int main(int argc, char *argv[]) {

       
    gStart=time(NULL);//开始时间戳

    
    
    serial_Init();//串口初始化

    mqtt_init();//mqtt初始化

    mqtt_create(mosq);//创建mqtt客户端
 
    ipaddr();//获取ip
    mqtt_wirte();//mqtt心跳首次发送

    //opencamsh();
    
    thread_start(serial_usart1,AppExit,Mqttbeat,serial_usart2,opensh);
    mqtt_cycle(mosq);
   

    mqtt_clean(mosq);
    thread_end();

    return EXIT_SUCCESS;
}